Index: trunk/VUT/GtpVisibilityPreprocessor/src/RssPreprocessor.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/RssPreprocessor.cpp	(revision 490)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/RssPreprocessor.cpp	(revision 492)
@@ -11,4 +11,5 @@
 #include "ViewCellsManager.h"
 #include "RenderSimulator.h"
+#include "GlRenderer.h"
 
 static bool useViewSpaceBox = false;
@@ -33,5 +34,6 @@
   environment->GetIntValue("RssPreprocessor.Export.numRays", mExportNumRays);
   environment->GetBoolValue("RssPreprocessor.useViewcells", mUseViewcells);
-  environment->GetBoolValue("RssPreprocessor.useViewcells", mUseViewcells);
+  environment->GetBoolValue("RssPreprocessor.objectBasedSampling", mObjectBasedSampling);
+  environment->GetBoolValue("RssPreprocessor.directionalSampling", mDirectionalSampling);
 
   environment->GetBoolValue("RssPreprocessor.loadInitialSamples", mLoadInitialSamples);
@@ -39,9 +41,11 @@
   
   mStats.open("stats.log");
+
 }
 
 RssPreprocessor::~RssPreprocessor()
 {
-  CLEAR_CONTAINER(mVssRays);
+  // mVssRays get deleted in the tree
+  //  CLEAR_CONTAINER(mVssRays);
 }
 
@@ -78,4 +82,5 @@
   Vector3 pointA, pointB;
   float bsize = Magnitude(box.Size());
+
   
   if (mKdTree->CastRay(ray)) {
@@ -86,10 +91,8 @@
 	// compute intersection with the scene bounding box
 	float tmin, tmax;
-	box.ComputeMinMaxT(ray, &tmin, &tmax);
-	if (tmax > bsize) {
-	  //cerr<<"Warning: tmax > box size tmax="<<tmax<<" tmin="<<tmin<<" size="<<bsize<<endl;
-	  //cerr<<"ray"<<ray<<endl;
-	}
-	pointA = ray.Extrap(tmax);
+	if (box.ComputeMinMaxT(ray, &tmin, &tmax) && tmin < tmax)
+	  pointA = ray.Extrap(tmax);
+	else
+	  return 0;
   }
 
@@ -108,16 +111,25 @@
 	objectB = NULL;
 	float tmin, tmax;
-	box.ComputeMinMaxT(ray, &tmin, &tmax);
-	if (tmax > bsize) {
-	  //cerr<<"Warning: tmax > box size tmax="<<tmax<<" tmin="<<tmin<<" size="<<bsize<<endl;
-	  //cerr<<"ray"<<ray<<endl;
-	}
-	pointB = ray.Extrap(tmax);
-  }
-
+	if (box.ComputeMinMaxT(ray, &tmin, &tmax) && tmin < tmax)
+	  pointB = ray.Extrap(tmax);
+	else
+	  return 0;
+  }
+
+  //  if (objectA == NULL && objectB != NULL) {
+  if (1) {
+	// cast again to ensure that there is no objectA
+	SetupRay(ray, pointB, direction);
+	if (mKdTree->CastRay(ray)) {
+	  objectA = ray.intersections[0].mObject;
+	  pointA = ray.Extrap(ray.intersections[0].mT);
+	}
+  }
+  
+  
   VssRay *vssRay  = NULL;
 
-  bool validSample = true;
-  if (detectEmptyViewSpace) {
+  bool validSample = (objectA != objectB);
+  if (0 && detectEmptyViewSpace) {   // consider all samples valid
 	// check if the viewpoint lies on the line segment AB
 	if (Distance(pointA, pointB) <
@@ -176,8 +188,25 @@
   Vector3 point;
   if (!use2dSampling) {
-	Vector3 normal;
-	int i = (int)RandomValue(0, (Real)((int)mObjects.size()-1));
-	Intersectable *object = mObjects[i];
-	object->GetRandomSurfacePoint(point, normal);
+	if (mObjectBasedSampling) {
+	  Vector3 normal;
+	  int i = RandomValue(0, mObjects.size()-1);
+	  Intersectable *object = mObjects[i];
+	  object->GetRandomSurfacePoint(point, normal);
+	} else {
+	  // select
+	  if (mDirectionalSampling) {
+		point = viewpoint + UniformRandomVector();
+	  } else {
+		// select the other point uniformly distruted in the whole viewspace
+		AxisAlignedBox3 box;
+		
+		if (viewSpaceBox)
+		  box =*viewSpaceBox;
+		else 
+		  box = mKdTree->GetBox();
+		
+		point = box.GetRandomPoint();
+	  }
+	}
   } else {
 	AxisAlignedBox3 box;
@@ -187,9 +216,52 @@
 	else 
 	  box = mKdTree->GetBox();
-		
+	
 	point = box.GetRandomPoint();
 	point.y = viewpoint.y;
   }
 	
+  return point - viewpoint;
+}
+
+Vector3
+RssPreprocessor::InitialGetDirection(const Vector3 &viewpoint,
+									 AxisAlignedBox3 *viewSpaceBox
+									 )
+{
+  Vector3 point;
+  if (!use2dSampling) {
+	if (1 || mObjectBasedSampling) {
+	  Vector3 normal;
+	  int i = RandomValue(0, mObjects.size()-1);
+	  Intersectable *object = mObjects[i];
+	  object->GetRandomSurfacePoint(point, normal);
+	} else {
+	  // select
+	  if (1 || mDirectionalSampling) {
+		point = viewpoint + UniformRandomVector();
+	  } else {
+		// select the other point uniformly distruted in the whole viewspace
+		AxisAlignedBox3 box;
+		
+		if (viewSpaceBox)
+		  box =*viewSpaceBox;
+		else 
+		  box = mKdTree->GetBox();
+		
+		point = box.GetRandomPoint();
+	  }
+	}
+  } else {
+	AxisAlignedBox3 box;
+	
+	if (viewSpaceBox)
+	  box =*viewSpaceBox;
+	else 
+	  box = mKdTree->GetBox();
+	
+	point = box.GetRandomPoint();
+	point.y = viewpoint.y;
+  }
+  
   return point - viewpoint;
 }
@@ -203,30 +275,16 @@
   int num;
 
-
-  
-  float avgPvsSize;
-  float avgRayContribution;
-  float avgPvsEntropy;
-  float avgRayLengthEntropy;
-  float avgImportance;
-  float avgRays;
-  rssTree->GetTreeStatistics(
-							 avgPvsSize,
-							 avgRays,
-							 avgRayContribution,
-							 avgPvsEntropy,
-							 avgRayLengthEntropy,
-							 avgImportance);
-  
+  rssTree->UpdateTreeStatistics();
+
   cout<<
-	"#RSS_AVG_PVS_SIZE\n"<<avgPvsSize<<endl<<
-	"#RSS_AVG_RAYS\n"<<avgRays<<endl<<
-	"#RSS_AVG_RAY_CONTRIB\n"<<avgRayContribution<<endl<<
-	"#RSS_AVG_PVS_ENTROPY\n"<<avgPvsEntropy<<endl<<
-	"#RSS_AVG_RAY_LENGTH_ENTROPY\n"<<avgRayLengthEntropy<<endl<<
-	"#RSS_AVG_IMPORTANCE\n"<<avgImportance<<endl;
+	"#RSS_AVG_PVS_SIZE\n"<<rssTree->stat.avgPvsSize<<endl<<
+	"#RSS_AVG_RAYS\n"<<rssTree->stat.avgRays<<endl<<
+	"#RSS_AVG_RAY_CONTRIB\n"<<rssTree->stat.avgRayContribution<<endl<<
+	"#RSS_AVG_PVS_ENTROPY\n"<<rssTree->stat.avgPvsEntropy<<endl<<
+	"#RSS_AVG_RAY_LENGTH_ENTROPY\n"<<rssTree->stat.avgRayLengthEntropy<<endl<<
+	"#RSS_AVG_IMPORTANCE\n"<<rssTree->stat.avgImportance<<endl;
   
   if (0) {
-	float p = desiredSamples/(float)(avgRayContribution*rssTree->stat.Leaves());
+	float p = desiredSamples/(float)(rssTree->stat.avgRayContribution*rssTree->stat.Leaves());
 	num = rssTree->GenerateRays(p, rays);
   } else {
@@ -249,7 +307,4 @@
   cout<<"Exporting vss rays..."<<endl<<flush;
 	
-  float prob = number/(float)vssRays.size();
-
-
   Exporter *exporter = NULL;
   exporter = Exporter::GetExporter(filename);
@@ -266,7 +321,7 @@
   }
 	
-  VssRayContainer rays;	for (int i=0; i < vssRays.size(); i++)
-	if (RandomValue(0,1) < prob)
-	  rays.push_back(vssRays[i]);
+  VssRayContainer rays;
+  
+  vssRays.SelectRays( number, rays);
 
   exporter->ExportRays(rays, RgbColor(1, 0, 0));
@@ -388,10 +443,33 @@
 }
 
+
+void
+RssPreprocessor::ComputeRenderError()
+{
+  // compute rendering error
+  if (renderer) {
+	emit EvalPvsStat();
+	QMutex mutex;
+	mutex.lock();
+	renderer->mRenderingFinished.wait(&mutex);
+	mutex.unlock();
+	mStats <<
+	  "#AvgPvsRenderError\n" <<renderer->mPvsStat.GetAvgError()<<endl<<
+	  "#MaxPvsRenderError\n" <<renderer->mPvsStat.GetMaxError()<<endl<<
+	  "#ErrorFreeFrames\n" <<renderer->mPvsStat.GetErrorFreeFrames()<<endl;
+  }
+}
+
 bool
 RssPreprocessor::ComputeVisibility()
 {
+  
+  connect(this, SIGNAL(EvalPvsStat()), renderer, SLOT(EvalPvsStat()) );
+  
   cout<<"Rss Preprocessor started\n"<<flush;
   cout<<"Memory/ray "<<sizeof(VssRay)+sizeof(RssTreeNode::RayInfo)<<endl;
-  mSceneGraph->CollectObjects(&mObjects);
+
+  Randomize(0);
+  
 	
   long startTime = GetTime();
@@ -443,96 +521,104 @@
 
   RssTree *rssTree = NULL;
-
-  if (mLoadInitialSamples)
-  {
-	  cout << "Loading samples from file ... ";
-	  LoadSamples(mVssRays, mObjects);
-	  cout << "finished\n" << endl;
-  }
-  else
-  {
+  int rssPass = 0;
+  int rssSamples = 0;
+
+#if 0
+  if (mLoadInitialSamples) {
+	cout << "Loading samples from file ... ";
+	LoadSamples(mVssRays, mObjects);
+	cout << "finished\n" << endl;
+  } else {
+#endif
 	while (totalSamples < mInitialSamples) {
-		int passContributingSamples = 0;
-		int passSampleContributions = 0;
-		int passSamples = 0;
-		int index = 0;
-			
-		int sampleContributions;
-			
-		int s = Min(mSamplesPerPass, mInitialSamples);
-		for (int k=0; k < s; k++) {
-				
+	  int passContributingSamples = 0;
+	  int passSampleContributions = 0;
+	  int passSamples = 0;
+	  int index = 0;
+	  
+	  int sampleContributions;
+	  
+	  //int s = Min(mSamplesPerPass, mInitialSamples);
+	  int s = mInitialSamples;
+	  
+	  for (int k=0; k < s; k++) {
+		
+		
 		//Vector3 viewpoint = GetViewpoint(mViewSpaceBox);
 		Vector3 viewpoint; 
-		mViewCellsManager->GetViewPoint(viewpoint);
-		Vector3 direction = GetDirection(viewpoint, mViewSpaceBox);
-				
+		//		mViewCellsManager->GetViewPoint(viewpoint);
+		viewpoint = GetViewpoint(mViewSpaceBox);
+		Vector3 direction = InitialGetDirection(viewpoint, mViewSpaceBox);
+		
 		sampleContributions = CastRay(viewpoint, direction, mVssRays);
-				
-				
+		
+		
 		//-- CORR matt: put block inside loop
 		if (sampleContributions) {
-			passContributingSamples ++;
-			passSampleContributions += sampleContributions;
+		  passContributingSamples ++;
+		  passSampleContributions += sampleContributions;
 		}
 		passSamples++;
 		totalSamples++;
-		}
-	    
-			
-		float avgRayContrib = (passContributingSamples > 0) ? 
+	  }
+	  
+	  
+	  float avgRayContrib = (passContributingSamples > 0) ? 
 		passSampleContributions/(float)passContributingSamples : 0;
-			
-		cout << "#Pass " << mPass << " : t = " << TimeDiff(startTime, GetTime())*1e-3 << "s" << endl;
-		cout << "#TotalSamples=" << totalSamples/1000 
-			<< "k   #SampleContributions=" << passSampleContributions << " (" 
-			<< 100*passContributingSamples/(float)passSamples<<"%)" 
-			<< "avgcontrib=" << avgRayContrib << endl;
-			
-		mStats <<
+	  
+	  cout << "#Pass " << mPass << " : t = " << TimeDiff(startTime, GetTime())*1e-3 << "s" << endl;
+	  cout << "#TotalSamples=" << totalSamples/1000 
+		   << "k   #SampleContributions=" << passSampleContributions << " (" 
+		   << 100*passContributingSamples/(float)passSamples<<"%)" 
+		   << "avgcontrib=" << avgRayContrib << endl;
+	  
+	  mPass++;
+	}
+	  
+	cout << "#totalPvsSize=" << mKdTree->CollectLeafPvs() << endl;
+	cout << "#totalRayStackSize=" << (int)mVssRays.size() << endl <<flush;
+	
+	rssSamples += mVssRays.size();
+	
+	
+	if (mExportRays) {
+	  char filename[64];
+	  sprintf(filename, "rss-rays-initial.x3d");
+	  ExportRays(filename, mVssRays, mExportNumRays);
+	}
+	
+	if (mStoreInitialSamples)
+	  {
+		cout << "Writing samples to file ... ";
+		WriteSamples(mVssRays);
+		cout << "finished\n" << endl;
+	  }
+	
+	if (mUseViewcells) {
+	  // construct view cells
+	  mViewCellsManager->Construct(mObjects, mVssRays);
+	  // evaluate contributions of the intitial rays
+	  mViewCellsManager->ComputeSampleContributions(mVssRays);
+	  
+	  
+	  mStats <<
 		"#Pass\n" <<mPass<<endl<<
-		"#Time\n" << TimeDiff(startTime, GetTime())*1e-3 << endl<<
-		"#TotalSamples\n" << totalSamples<< endl<<
-		"#SampleContributions\n" << passSampleContributions << endl << 
-		"#PContributingSamples\n"<<100*passContributingSamples/(float)passSamples<<endl <<
-		"#AvgRayContrib\n" << avgRayContrib << endl;
-		
-		mPass++;
-
-	}
-  
-	cout << "#totalPvsSize=" << mKdTree->CollectLeafPvs() << endl;
-  }
-
-  cout << "#totalRayStackSize=" << (int)mVssRays.size() << endl <<flush;
-  
-
-  if (mExportRays) {
-	char filename[64];
-	sprintf(filename, "rss-rays-initial.x3d");
-	ExportRays(filename, mVssRays, mExportNumRays);
-  }
-  
-  if (mStoreInitialSamples)
-  {
-	  cout << "Writing samples to file ... ";
-	  WriteSamples(mVssRays);
-	  cout << "finished\n" << endl;
-  }
-
-  if (mUseViewcells) {
-	// construct view cells
-	mViewCellsManager->Construct(mObjects, mVssRays);
-	
+		"#RssPass\n" <<rssPass<<endl<<
+		"#Time\n" << TimeDiff(startTime, GetTime())*1e-3<<endl<<
+		"#TotalSamples\n" <<totalSamples<<endl<<
+		"#RssSamples\n" <<rssSamples<<endl;
+	  
+	ComputeRenderError();
+
+	mVssRays.PrintStatistics(mStats);
+	mViewCellsManager->PrintPvsStatistics(mStats);
+
 	VssRayContainer selectedRays;
 	int desired = Max(
 					  mViewCellsManager->GetPostProcessSamples(),
 					  mViewCellsManager->GetVisualizationSamples());
-	float p = desired/(float)mVssRays.size();
-	
-	for (int i=0; i < mVssRays.size(); i++) {
-	  if (Random(1.0f) < p)
-		selectedRays.push_back(mVssRays[i]);
-	}
+
+	mVssRays.SelectRays(desired, selectedRays);
+	
 	//-- post process view cells
 	mViewCellsManager->PostProcess(mObjects, selectedRays);
@@ -547,6 +633,10 @@
 
 
+  
+  rssPass++;
+  
   rssTree = new RssTree;
-	
+  rssTree->SetPass(mPass);
+  
   if (mUseImportanceSampling) {
 	
@@ -555,4 +645,6 @@
 	else
 	  rssTree->Construct(mVssRays, NULL);
+
+	rssTree->stat.Print(mStats);
 	cout<<"RssTree root PVS size = "<<rssTree->GetRootPvsSize()<<endl;
 	
@@ -572,11 +664,11 @@
   // viewcells->UpdatePVS(newVssRays);
   
-  int rssPass = 0;
-  int rssSamples = 0;
+
   while (1) {
 	int num = mRssSamplesPerPass;
 	SimpleRayContainer rays;
 	VssRayContainer vssRays;
-		
+
+
 	if (!mUseImportanceSampling) {
 	  for (int j=0; j < num; j++) {
@@ -597,7 +689,9 @@
 
 	
-	totalSamples+=num;
-	rssSamples+=num;
-
+	totalSamples += rays.size();
+	rssSamples += vssRays.size();
+
+	
+	
 	mStats <<
 	  "#Pass\n" <<mPass<<endl<<
@@ -607,4 +701,5 @@
 	  "#RssSamples\n" <<rssSamples<<endl;
 
+
 	if (mUseViewcells) {
 	  
@@ -616,24 +711,9 @@
 	}
 
-	// add rays to the tree after the viewcells have been cast to have their contributions
-	// already when adding into the tree
-	// do not add those rays which have too low or no contribution....
-	
-	if (mUseImportanceSampling) {
-	  rssTree->AddRays(vssRays);
-	  
-	  if (0) {
-		cout<<"############# Rss PVS STAT ##################\n";
-		cout<<"#AVG_RSS_PVS\n"<<rssTree->GetAvgPvsSize()<<endl;
-		cout<<"#RSS_ROOT_PVS\n"<<rssTree->GetRootPvsSize()<<endl;
-	  }
-	  
-	  if (mUpdateSubdivision) {
-		int subdivided = rssTree->UpdateSubdivision();
-		cout<<"subdivided leafs = "<<subdivided<<endl;
-		cout<<"#total leaves = "<<rssTree->stat.Leaves()<<endl;
-	  }
-	}
-	
+
+	ComputeRenderError();
+	
+	// epxort rays before adding them to the tree -> some of them can be deleted
+
 	if (mExportRays) {
 	  char filename[64];
@@ -644,5 +724,38 @@
 	  
 	  ExportRays(filename, vssRays, mExportNumRays);
-	}
+
+	  // now export all contributing rays
+	  VssRayContainer contributingRays;
+	  vssRays.GetContributingRays(contributingRays, mPass);
+	  mStats<<"#NUM_CONTRIBUTING_RAYS\n"<<contributingRays.size()<<endl;
+	  sprintf(filename, "rss-crays-%04d.x3d", rssPass);
+	  ExportRays(filename, contributingRays, mExportNumRays);
+	}
+
+	
+	// add rays to the tree after the viewcells have been cast to have their contributions
+	// already when adding into the tree
+	// do not add those rays which have too low or no contribution....
+	
+	if (mUseImportanceSampling) {
+	  rssTree->AddRays(vssRays);
+	  
+	  if (0) {
+		cout<<"############# Rss PVS STAT ##################\n";
+		cout<<"#AVG_RSS_PVS\n"<<rssTree->GetAvgPvsSize()<<endl;
+		cout<<"#RSS_ROOT_PVS\n"<<rssTree->GetRootPvsSize()<<endl;
+	  }
+	  
+	  
+	  if (mUpdateSubdivision) {
+		int updatePasses = 1;
+		if (mPass % updatePasses == 0) {
+		  int subdivided = rssTree->UpdateSubdivision();
+		  cout<<"subdivided leafs = "<<subdivided<<endl;
+		  cout<<"#total leaves = "<<rssTree->stat.Leaves()<<endl;
+		}
+	  }
+	}
+	
 
 	
@@ -653,4 +766,8 @@
 	}
 
+	
+	if (!mUseImportanceSampling) 
+	  CLEAR_CONTAINER(vssRays);
+
 	if (totalSamples >= mRssSamples + mInitialSamples)
 	  break;
@@ -659,4 +776,5 @@
 	rssPass++;
 	mPass++;
+	rssTree->SetPass(mPass);
   }
   
Index: trunk/VUT/GtpVisibilityPreprocessor/src/VssPreprocessor.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/VssPreprocessor.cpp	(revision 491)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/VssPreprocessor.cpp	(revision 492)
@@ -351,5 +351,4 @@
 {
 
-  mSceneGraph->CollectObjects(&mObjects);
 
   long startTime = GetTime();
Index: trunk/VUT/GtpVisibilityPreprocessor/src/main.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/main.cpp	(revision 487)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/main.cpp	(revision 492)
@@ -13,10 +13,18 @@
 #include "ViewCell.h"
 #include "SceneGraph.h"
+#include "PreprocessorThread.h"
+
+#include <QApplication>
+#include <QtOpenGL>
+#include "GlRenderer.h"
 
 #define USE_EXE_PATH false
 
 
+
+
+
 int
-main(int argc, const char **argv)
+main(int argc, char **argv)
 {
   Debug.open("debug.log");
@@ -24,5 +32,5 @@
   environment->Parse(argc, argv, USE_EXE_PATH);
   MeshKdTree::ParseEnvironment();
-   
+  
   char buff[128];
   environment->GetStringValue("Preprocessor.type", buff);
@@ -48,15 +56,19 @@
 		}
   
+  preprocessor = p;
   
-	environment->GetStringValue("Scene.filename", buff);
-	string filename(buff);
-	
-	p->LoadScene(filename);
-	
-	p->BuildKdTree();
-	p->KdTreeStatistics(cout);
-	
-	// parse view cells related options
-	p->PrepareViewCells();
+  environment->GetStringValue("Scene.filename", buff);
+  string filename(buff);
+  p->LoadScene(filename);
+  
+  p->BuildKdTree();
+  p->KdTreeStatistics(cout);
+  
+  // parse view cells related options
+  p->PrepareViewCells();
+  
+
+  // create a preprocessor thread
+  PreprocessorThread *pt = new PreprocessorThread(p);
 
   //  p->mSceneGraph->Export("soda.x3d");
@@ -65,33 +77,32 @@
     p->Export(filename + "-kdtree.x3d", false, true, false);	
   }
+
+  if (p->mUseGlRenderer) {
+	QApplication a(argc, argv);
+	
+	if (!QGLFormat::hasOpenGL() || !QGLPbuffer::hasPbuffers()) {
+	  QMessageBox::information(0, "OpenGL pbuffers", 
+							   "This system does not support OpenGL/pbuffers.",
+							   QMessageBox::Ok);
+	  return -1;
+	}
+	
+	renderer = new GlRenderer(p->mSceneGraph, p->mViewCellsManager);
+	//  renderer->resize(640, 480);
+	renderer->resize(1024, 768);
+	renderer->show();
+	
+	
+	pt->start(QThread::LowPriority);
+	
+	return a.exec();
+  } else {
+	// just call the mail method -> will be executed in the main thread
+	pt->Main();
+  }
   
-   
-  if (1) {
-    p->ComputeVisibility();
-    p->ExportPreprocessedData("scene.vis");
-  }
-
-	Camera camera;
-  if (0) {
-    //camera.LookAtBox(p->mKdTree->GetBox());
-		camera.LookInBox(p->mKdTree->GetBox());
-		camera.SetPosition(camera.mPosition + Vector3(0,300,0));
-    camera.SnapImage("camera.jpg", p->mKdTree);
-	}
-	if (0) {
-    camera.LookInBox(p->mKdTree->GetBox());
-    camera.SetPosition(camera.mPosition - Vector3(0,100,0));
-    camera.SnapImage("camera2.jpg", p->mKdTree);
-  }
-
-	if (0) {
-    camera.SetPosition( p->mKdTree->GetBox().Center() - Vector3(0,-100,0) );
-		camera.SetDirection(Vector3(1, 0, 0));
-		camera.SnapImage("camera3.jpg", p->mKdTree);
-  }
-
   // clean up
-  DEL_PTR(p);
-  DEL_PTR(environment);
+  //  DEL_PTR(p);
+  //  DEL_PTR(environment);
 
   return 0;
Index: trunk/VUT/GtpVisibilityPreprocessor/src/VssRay.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/VssRay.cpp	(revision 487)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/VssRay.cpp	(revision 492)
@@ -139,5 +139,5 @@
   point = GetOrigin() + t*dir;
   
-  return SqrDistance(point, center) < sqrRadius;
+  return ::SqrDistance(point, center) < sqrRadius;
 }
 
@@ -153,4 +153,11 @@
 {
   Vector3 dir = GetNormalizedDir();
+  return GetDirParam(axis, dir);
+}
+
+float
+VssRay::GetOpositeDirParametrization(const int axis) const
+{
+  Vector3 dir = -GetNormalizedDir();
   return GetDirParam(axis, dir);
 }
@@ -217,2 +224,35 @@
   
 }
+
+
+int
+VssRayContainer::SelectRays(const int number,
+							VssRayContainer &selected) const
+{
+  float p = number/(float)size();
+  VssRayContainer::const_iterator it = begin();
+  
+  for (; it != end(); it++)
+	if (Random(1.0f) < p)
+	  selected.push_back(*it);
+  
+  return selected.size();
+}
+
+
+int
+VssRayContainer::GetContributingRays(VssRayContainer &selected,
+									 const int minPass
+									 ) const
+{
+  VssRayContainer::const_iterator it = begin();
+  
+  for (; it != end(); it++) {
+	VssRay *ray = *it;
+	if (ray->mPass >= minPass && ray->mPvsContribution > 0)
+	  selected.push_back(ray);
+  }
+  return selected.size();
+}
+
+
Index: trunk/VUT/GtpVisibilityPreprocessor/src/Intersectable.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/Intersectable.h	(revision 387)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/Intersectable.h	(revision 492)
@@ -5,4 +5,5 @@
 #include "Pvs.h"
 
+class VssRayContainer;
 
 class Intersectable {
@@ -54,19 +55,25 @@
   virtual float IntersectionComplexity() = 0;
   
-	virtual int NumberOfFaces() const = 0;
+  virtual int NumberOfFaces() const = 0;
 
-	virtual int Type() const = 0;
-
+  virtual int Type() const = 0;
+  
   virtual int GetRandomSurfacePoint(Vector3 &point, Vector3 &normal) = 0;
-
-	virtual int
-	GetRandomVisibleSurfacePoint(Vector3 &point,
-															 Vector3 &normal,
-															 const Vector3 &viewpoint,
+  
+  virtual int
+  GetRandomVisibleSurfacePoint(Vector3 &point,
+							   Vector3 &normal,
+							   const Vector3 &viewpoint,
 															 const int maxTries
-															 ) = 0;
-
-	virtual ostream &Describe(ostream &s) = 0;
-	
+							   ) = 0;
+  
+  virtual ostream &Describe(ostream &s) = 0;
+  
+  virtual int GenerateSilhouetteRays(const int nrays,
+									 const AxisAlignedBox3 &originBox,
+									 const AxisAlignedBox3 &directionBox,
+									 VssRayContainer &rays
+									 ) {return 0;}
+  
 };
 
Index: trunk/VUT/GtpVisibilityPreprocessor/src/default.env
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/default.env	(revision 467)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/default.env	(revision 492)
@@ -15,5 +15,5 @@
 # filename ../data/atlanta/atlanta2.x3d
 # filename ../data/soda/soda.dat
- filename ../data/soda/soda5.dat
+filename ../data/soda/soda5.dat
 }
 
@@ -22,4 +22,5 @@
 #	type vss
 	type rss
+	useGlRenderer true
 }
 
@@ -66,6 +67,9 @@
 	initialSamples 500000
 	vssSamples 10000000
-	vssSamplesPerPass 100000
+	vssSamplesPerPass 500000
 	useImportanceSampling true
+
+	directionalSampling true
+	objectBasedSampling false
 
 	Export {
@@ -77,5 +81,5 @@
 
 	useViewcells true
-	updateSubdivision false
+	updateSubdivision true
 }
 
@@ -88,7 +92,7 @@
 	minRays		30
 	minSize		0.001
- 	maxCostRatio	0.9
-	maxRayContribution 0.1
-	
+ 	maxCostRatio 1.0
+	maxRayContribution 0.5
+	maxRays		1000000
 	maxTotalMemory	200
 	maxStaticMemory	100
@@ -97,5 +101,6 @@
 #	splitType heuristic
 	splitType hybrid
-	splitUseOnlyDrivingAxis false
+	splitUseOnlyDrivingAxis true
+	importanceBasedCost false
 
 	interleaveDirSplits	true
@@ -157,5 +162,5 @@
 	#type kdTree
 	#type vspKdTree
-	#type bspTree
+	# type bspTree
 	type vspBspTree
 	
@@ -184,96 +189,4 @@
 }
 
-BspTree {
-	Construction {
-		samples 50000
-		epsilon 0.005
-	}
-
-	# random polygon       = 1
-	# axis aligned         = 2
-	# least splits         = 4
-	# balanced polygons    = 8
-	# balanced view cells  = 16
-	# largest polygon area = 32
-	# vertical axis        = 64
-	# blocked rays         = 128
-	# least ray splits     = 256
-	# balanced rays        = 512
-	# pvs                  = 1024
-
-	# least splits + balanced polygons
-	#splitPlaneStrategy 12
-	
-	#axis aligned + vertical axis
-	#splitPlaneStrategy 66
-	
-	# axis aligned + balanced view cells
-	# splitPlaneStrategy 18
-	
-	# largest polygon area
-	#splitPlaneStrategy 32
-	
-	# axus aligned + balanced polygons
-	#splitPlaneStrategy 72
-	
-	# axis aligned + blocked rays
-	#splitPlaneStrategy 130
-	
-	#splitPlaneStrategy 384
-	#splitPlaneStrategy 130
-	
-	splitPlaneStrategy 1024
-	
-	maxPolyCandidates 50
-	maxRayCandidates 50
-	
-	maxTests 10000
-	
-	# factors for evaluating split plane costs
-	Factor {
-		verticalSplits 1.0
-	  	largestPolyArea 1.0
-	  	blockedRays 1.0
-	  	leastRaySplits 1.0
-	  	balancedRays 1.0
-	  	pvs 1.0
-	  	leastSplits 1.0
-	  	balancedPolys 1.0
-	  	balancedViewCells 1.0
-	}
-	
-	Termination {
-		# parameters used for autopartition
-		minRays 200
-		minPolygons -1
-		maxDepth 40
-		minPvs 100
-		minArea 0.01
-		maxRayContribution 0.005
-		#maxAccRayLength 100
-		
-		# used for pvs criterium
-		ct_div_ci 0.0
-		
-		# axis aligned splits
-		AxisAligned {
-			minPolys 5000
-			minRays 500
-			minObjects 10
-			maxCostRatio 0.9
-			ct_div_ci 0.5
-		}
-	}
-	
-	AxisAligned {
-		splitBorder 0.01
-	}
-	
-		
-	Visualization {
-	# x3d visualization of the split planes
-	exportSplits true
-	}
-}
 
 Simulation {
@@ -355,12 +268,12 @@
 			minRays 500
 			minObjects 10
-			maxCostRatio 0.9
-			ct_div_ci 0.5
+#			maxCostRatio 0.9
+#			ct_div_ci 0.5
 		}
 	}
 	
-	AxisAligned {
-		splitBorder 0.01
-	}
+#	AxisAligned {
+#		splitBorder 0.01
+#	}
 	
 	
Index: trunk/VUT/GtpVisibilityPreprocessor/src/Preprocessor.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/Preprocessor.h	(revision 490)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/Preprocessor.h	(revision 492)
@@ -7,4 +7,6 @@
 #include "Mesh.h"
 #include "KdTree.h"
+
+#include <QObject>
 
 class RenderSimulator;
@@ -30,5 +32,7 @@
       viewcell loading/generation and the visibility computation itself.
   */
-class Preprocessor {
+class Preprocessor : public QObject {
+  Q_OBJECT
+
 public:
 	/** Default constructor initialising e.g., KD tree and BSP tree.
@@ -94,4 +98,7 @@
   /// scene graph loaded from file
   SceneGraph *mSceneGraph;
+
+  /// raw array of objects
+  ObjectContainer mObjects;
   
   /// kD-tree organizing the scene graph (occluders + occludees) + viewcells
@@ -115,12 +122,26 @@
   VspKdTree *mVspKdTree;
 
+  bool mUseGlRenderer;
+  
+protected:
+
+  /////////////////////////
+
+  /// samples used for construction of the BSP view cells tree.
+  int mBspConstructionSamples;
+   /// samples used for construction of the VSP KD tree.
+  int mVspKdConstructionSamples;
   /** Simulates rendering of the scene.
   */
   RenderSimulator *mRenderSimulator;
+
+  signals:
+  void EvalPvsStat();
+
 };
 
 
 
-
+extern Preprocessor *preprocessor;
 
 #endif
Index: trunk/VUT/GtpVisibilityPreprocessor/src/GlRenderer.h
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/GlRenderer.h	(revision 492)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/GlRenderer.h	(revision 492)
@@ -0,0 +1,121 @@
+#ifndef __RENDERER_H
+#define __RENDERER_H
+
+#include <QtOpenGL>
+#include <QWaitCondition>
+
+#include "Vector3.h"
+#include "Containers.h"
+#include "Halton.h"
+
+class SceneGraph;
+class ViewCellsManager;
+class Mesh;
+class MeshInstance;
+class Intersectable;
+class Material;
+
+struct PvsRenderStatistics {
+  
+  float maxError;
+  float sumError;
+  int frames;
+  int errorFreeFrames;
+  
+  PvsRenderStatistics() { Reset(); }
+  
+  Reset() {
+	maxError = 0.0f;
+	sumError = 0.0f;
+	frames = 0;
+	errorFreeFrames = 0;
+  }
+
+  float GetMaxError() { return maxError; }
+  float GetAvgError() { return sumError/frames; }
+  float GetErrorFreeFrames() { return errorFreeFrames/(float)frames; }
+  
+};
+
+class GlRenderer : public QGLWidget
+{
+  Q_OBJECT
+public:
+  SceneGraph *mSceneGraph;
+  ObjectContainer mObjects;
+  ViewCellsManager *mViewCellsManager;
+  
+  Vector3 mViewPoint;
+  Vector3 mViewDirection;
+
+  int timerId;
+  Vector3 mousePoint;
+  bool mUseFalseColors;
+
+  HaltonSequence halton;
+  
+  bool mRender;
+  int mFrame;
+
+  int mPvsStatFrames;
+  vector<float> mPvsErrorBuffer;
+  
+  PvsRenderStatistics mPvsStat;
+  
+  QWaitCondition mRenderingFinished;
+
+  QGLPbuffer *pbuffer;
+  
+  
+  GlRenderer(SceneGraph *sceneGraph,
+		   ViewCellsManager *viewcells);
+
+  ~GlRenderer();
+
+  void SetupFalseColor(const int id);
+  
+  void RenderIntersectable(Intersectable *);
+  void RenderMeshInstance(MeshInstance *mi);
+  void RenderMesh(Mesh *m);
+  void SetupMaterial(Material *m);
+  void SetupCamera();
+  void RandomViewPoint();
+
+  void initializeGL();
+  void resizeGL(int w, int h);
+  void paintGL();
+  void timerEvent(QTimerEvent *) {
+	if (mRender) 
+	  update();
+  }
+
+  void mousePressEvent(QMouseEvent *);
+  void mouseReleaseEvent(QMouseEvent *);
+  void mouseMoveEvent(QMouseEvent *);
+
+  void
+  ClearErrorBuffer();
+
+  void
+  RenderScene();
+
+  void
+  SetupProjection(const int w, const int h);
+
+ public slots:
+ void
+ EvalPvsStat();
+  
+  float Render();
+
+  float
+  GetPixelError();
+
+
+};
+
+
+extern GlRenderer *renderer;
+
+#endif
+
Index: trunk/VUT/GtpVisibilityPreprocessor/src/preprocessor.pro
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/preprocessor.pro	(revision 463)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/preprocessor.pro	(revision 492)
@@ -16,5 +16,5 @@
 
 # debuc config
-CONFIG		+= console warn_off thread release
+CONFIG		+= console warn_off thread release qt
 
 # RELEASE CONFIG
@@ -23,9 +23,12 @@
 # DEPENDPATH	= ../../include
 
+QT += opengl
+
 win32:LIBS += xerces-c_2.lib devil.lib ilu.lib ilut.lib
 unix:LIBS += -lxerces-c -lIL -lILU -lILUT
 
 # Input
-HEADERS += Halton.h VssRay.h VssPreprocessor.h RssTree.h
+HEADERS += Halton.h VssRay.h VssPreprocessor.h RssTree.h GlRenderer.h \
+PreprocessorThread.h Preprocessor.h
 
 
@@ -39,4 +42,5 @@
 ViewCell.cpp ViewCellBsp.cpp Halton.cpp VssRay.cpp VssTree.cpp VssPreprocessor.cpp \
 RenderSimulator.cpp VspKdTree.cpp RayInfo.cpp RssTree.cpp RssPreprocessor.cpp \
-ViewCellsManager.cpp VspBspTree.cpp
+ViewCellsManager.cpp VspBspTree.cpp GlRenderer.cpp \
+PreprocessorThread.cpp Renderer.cpp
 
Index: trunk/VUT/GtpVisibilityPreprocessor/src/PreprocessorThread.cpp
===================================================================
--- trunk/VUT/GtpVisibilityPreprocessor/src/PreprocessorThread.cpp	(revision 492)
+++ trunk/VUT/GtpVisibilityPreprocessor/src/PreprocessorThread.cpp	(revision 492)
@@ -0,0 +1,47 @@
+#include <QApplication>
+
+#include "PreprocessorThread.h"
+#include "Camera.h"
+#include "KdTree.h"
+#include "SceneGraph.h"
+#include "Preprocessor.h"
+
+
+
+PreprocessorThread::PreprocessorThread(Preprocessor *p,
+									   QObject *parent):QThread(parent)
+{
+  mPreprocessor = p;
+}
+
+void
+PreprocessorThread::Main()
+{
+     
+  if (1) {
+    mPreprocessor->ComputeVisibility();
+    mPreprocessor->ExportPreprocessedData("scene.vis");
+  }
+  
+  Camera camera;
+  if (0) {
+    camera.LookAtBox(mPreprocessor->mKdTree->GetBox());
+	//	camera.LookInBox(mPreprocessor->mKdTree->GetBox());
+	//	camera.SetPosition(camera.mPosition + Vector3(0,300,0));
+    camera.SnapImage("camera.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
+  }
+  if (0) {
+    camera.LookInBox(mPreprocessor->mKdTree->GetBox());
+    camera.SetPosition(camera.mPosition + Vector3(-250,0,-550));
+    camera.SnapImage("camera2.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
+  }
+
+  if (0) {
+    camera.SetPosition( mPreprocessor->mKdTree->GetBox().Center() - Vector3(0,-100,0) );
+	camera.SetDirection(Vector3(1, 0, 0));
+	camera.SnapImage("camera3.jpg", mPreprocessor->mKdTree, mPreprocessor->mSceneGraph);
+  }
+
+  QApplication::quit();
+  
+}
